/*
 * ------------------------------------------------------------------------
 * 
 * GateD, Release 3.5.5 
 * 
 * Copyright (c) 1996, 1997 The Regents of the University of Michigan
 * All Rights Reserved
 * 
 * License to use, copy, modify, and distribute this software and its
 * documentation can be obtained from Merit at the University of Michigan.
 * 
 * Merit GateDaemon Project
 * 4251 Plymouth Road, Suite C
 * Ann Arbor, MI 48105
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER
 * EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. THE REGENTS OF THE
 * UNIVERSITY OF MICHIGAN AND MERIT DO NOT WARRANT THAT THE
 * FUNCTIONS CONTAINED IN THE SOFTWARE WILL MEET LICENSEE'S REQUIREMENTS OR
 * THAT OPERATION WILL BE UNINTERRUPTED OR ERROR FREE. The Regents of the
 * University of Michigan and Merit shall not be liable for
 * any special, indirect, incidental or consequential damages with respect
 * to any claim by Licensee or any third party arising from use of the
 * software. GateDaemon was originated and developed through release 3.0
 * by Cornell University and its collaborators.
 * 
 * Please forward bug fixes, enhancements and questions to the
 * gated mailing list: gated-people@gated.merit.edu.
 * 
 * ---------------------
 * 
 * Copyright (c) 1990,1991,1992,1993,1994,1995 by Cornell University.
 * All rights reserved.
 * 
 * THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
 * LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS FOR A PARTICULAR PURPOSE.
 * 
 * Royalty-free licenses to redistribute GateD Release
 * 3 in whole or in part may be obtained by writing to:
 * 
 * GateDaemon Project
 * Information Technologies/Network Resources
 * 200 CCC
 * Cornell University
 * Ithaca, NY  14853-2601  USA
 * 
 * GateD is based on Kirton's EGP, UC Berkeley's routing
 * daemon	 (routed), and DCN's HELLO routing Protocol.
 * Development of GateD has been supported in part by the
 * National Science Foundation.
 * 
 * Please forward bug fixes, enhancements and questions to the
 * gated mailing list: gated-people@gated.cornell.edu.
 * 
 * ------------------------------------------------------------------------
 * 
 * Portions of this software may fall under the following
 * copyrights:
 * 
 * Copyright (c) 1988 Regents of the University of California.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms are
 * permitted provided that the above copyright notice and
 * this paragraph are duplicated in all such forms and that
 * any documentation, advertising materials, and other
 * materials related to such distribution and use
 * acknowledge that the software was developed by the
 * University of California, Berkeley.  The name of the
 * University may not be used to endorse or promote
 * products derived from this software without specific
 * prior written permission.  THIS SOFTWARE IS PROVIDED
 * ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES,
 * INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 * This copyright has ben automaticly added by the util/addcopyright.pl program.
 * __END_OF_COPYRIGHT__
 */

/*^M
 *  krt_symbols_sysctl.c,v 1.4.2.1 1994/08/15 20:24:03 jch Exp^M
 */^M

/* Gated Release 3.5 */^M
/* Copyright (c) 1990,1991,1992,1993,1994,1995 by Cornell University.  All */^M
/* rights reserved.  Refer to Particulars and other Copyright notices at */^M
/* the end of this file.  */^M
/*  */^M


#define       INCLUDE_UDP^M
#define       INCLUDE_UDP_VAR^M
#define       INCLUDE_KVM^M
#include "include.h"^M
#ifdef        PROTO_INET^M
#include "inet.h"^M
#endif        /* PROTO_INET */^M
#include "krt.h"^M
struct __kvm {^M
    int kvm_fd;^M
    const char *kvm_nl;^M
    const char *kvm_core;^M
    const char *kvm_swap;^M
    char kvm_errmsg[BUFSIZ];^M
};^M
#include "krt_var.h"^M
#include <sys/ksym.h>^M

int^M
krt_symbols __PF1(tp, task *)^M
{^M
    char buf[BUFSIZ];^M
    struct mioc_rksym rks;^M
^M
    rks.mirk_symname = KSYM_VERSION;^M
    rks.mirk_buf = buf;^M
    rks.mirk_buflen = sizeof(buf);^M
    if (ioctl(kd->kvm_fd, MIOC_READKSYM, &rks) < 0) {^M
      trace_log_tp(tp,^M
                   0,^M
                   LOG_INFO,^M
                   ("krt_symbols: mioc(KSYM_VERSION): %m"));^M
    } else {^M
      /* Set version */^M
^M
      krt_version_kernel = task_mem_strdup(tp, buf);^M
      trace_tp(tp,^M
               TR_KRT_SYMBOLS,^M
               0,^M
               ("krt_symbols: kernel version: %s\n",^M
                krt_version_kernel));^M
    }^M
^M
#ifdef        PROTO_INET^M
    rks.mirk_symname = KSYM_IPFORWARDING;^M
    rks.mirk_buf = buf;^M
    rks.mirk_buflen = sizeof(int);^M
    if (ioctl(kd->kvm_fd, MIOC_READKSYM, &rks) < 0) {^M
      trace_log_tp(tp,^M
                   0,^M
                   LOG_INFO,^M
                   ("krt_symbols: mioc(KSYM_IPFORWARDING): %m"));^M
    } else {^M
      inet_ipforwarding = *(int *)buf;^M
      trace_tp(tp,^M
               TR_KRT_SYMBOLS,^M
               0,^M
               ("krt_symbols: IP forwarding: %u\n",^M
                inet_ipforwarding));^M
    }^M
^M
    rks.mirk_symname = KSYM_UDPCKSUM;^M
    rks.mirk_buf = buf;^M
    rks.mirk_buflen = sizeof(int);^M
    if (ioctl(kd->kvm_fd, MIOC_READKSYM, &rks) < 0) {^M
      trace_log_tp(tp,^M
                   0,^M
                   LOG_INFO,^M
                   ("krt_symbols: mioc(KSYM_UDPCKSUM): %m"));^M
    } else {^M
      inet_udpcksum = *(int *)buf;^M
      trace_tp(tp,^M
               TR_KRT_SYMBOLS,^M
               0,^M
               ("krt_symbols: UDP checksum: %u\n",^M
                inet_udpcksum));^M
    }^M
#endif        /* PROTO_INET */^M
    ^M
    trace_tp(tp,^M
           TR_KRT_SYMBOLS,^M
           0,^M
           (NULL));^M
^M
    return 0;^M
}^M

